//+------------------------------------------------------------------+
//|                                            Bears Bulls Power.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2005-2014, MetaQuotes Software Corp. SEM"
#property link        "http://www.mql4.com"
#property description "Bears Power"
#property strict

//--- indicator settings
#property indicator_buffers 2

#property indicator_separate_window
#property indicator_label1 "Bears (Sell)"
#property indicator_color1 clrRed
#property indicator_type1  DRAW_HISTOGRAM  // DRAW_HISTOGRAM

#property indicator_label2 "Bulls (Buy)"
#property indicator_type2 DRAW_HISTOGRAM
#property indicator_color2  clrLime 
#property indicator_style2 STYLE_SOLID
#property indicator_width2 1 
//--- input parameter
input int InpBearsPeriod=13; // Bears Period

extern ENUM_APPLIED_PRICE MA_PRICE=PRICE_CLOSE;
extern ENUM_MA_METHOD MA_MODE_EMA=MODE_EMA;

//--- buffers
double ExtBearsBuffer[];
double ExtBullsBuffer[];
double ExtTempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit(void)
  {
   string short_name;
//--- 1 additional buffer used for counting.
   IndicatorBuffers(3);
   IndicatorDigits(Digits);
//--- indicator line
//SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtBearsBuffer);
   SetIndexBuffer(1,ExtBullsBuffer);
   SetIndexBuffer(2,ExtTempBuffer);
//--- name for DataWindow and indicator subwindow label
   short_name="Bears (Sell) Bulls (Buy)("+IntegerToString(InpBearsPeriod)+")";
   IndicatorShortName(short_name);
//SetIndexLabel(0,short_name);
  }
//+------------------------------------------------------------------+
//| Bears Power                                                      |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int limit=rates_total-prev_calculated;
//---
   if(rates_total<=InpBearsPeriod)
      return(0);
//---
   if(prev_calculated>0)
      limit++;
   for(int i=0; i<limit; i++)
     {
      ExtTempBuffer[i]=(high[i]-iMA(NULL,0,InpBearsPeriod,0,MA_MODE_EMA,MA_PRICE,i))
                       +(low[i]-iMA(NULL,0,InpBearsPeriod,0,MA_MODE_EMA,MA_PRICE,i))+iAC(NULL,0,i)+iAO(NULL,0,i);
      //ExtBearsBuffer[i]=low[i]-ExtTempBuffer[i];
      //ExtBullsBuffer[i]=high[i]-ExtTempBuffer[i];

      if(ExtTempBuffer[i]>=0) ExtBullsBuffer[i]=ExtTempBuffer[i];
      else            ExtBearsBuffer[i]=ExtTempBuffer[i];

     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
